- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osg::Vec4f Class Reference

General purpose float quad. More...

List of all members.

## Public Types
typedef float | value_type
## Public Member Functions
| Vec4f ()
| Vec4f (value_type x, value_type y, value_type z, value_type w)
| Vec4f (const Vec3f &v3, value_type w)
bool | operator== (const Vec4f &v) const
bool | operator!= (const Vec4f &v) const
bool | operator< (const Vec4f &v) const
value_type * | ptr ()
const value_type * | ptr () const
void | set (value_type x, value_type y, value_type z, value_type w)
value_type & | operator[] (unsigned int i)
value_type | operator[] (unsigned int i) const
value_type & | x ()
value_type & | y ()
value_type & | z ()
value_type & | w ()
value_type | x () const
value_type | y () const
value_type | z () const
value_type | w () const
unsigned long | asABGR () const
unsigned long | asRGBA () const
bool | valid () const
bool | isNaN () const
value_type | operator * (const Vec4f &rhs) const
| Dot product.
Vec4f | operator * (value_type rhs) const
| Multiply by scalar.
Vec4f & | operator *= (value_type rhs)
| Unary multiply by scalar.
Vec4f | operator/ (value_type rhs) const
| Divide by scalar.
Vec4f & | operator/= (value_type rhs)
| Unary divide by scalar.
Vec4f | operator+ (const Vec4f &rhs) const
| Binary vector add.
Vec4f & | operator+= (const Vec4f &rhs)
| Unary vector add.
Vec4f | operator- (const Vec4f &rhs) const
| Binary vector subtract.
Vec4f & | operator-= (const Vec4f &rhs)
| Unary vector subtract.
const Vec4f | operator- () const
| Negation operator.
value_type | length () const
| Length of the vector = sqrt( vec .
value_type | length2 () const
| Length squared of the vector = vec .
value_type | normalize ()
| Normalize the vector so that it has length unity.
## Public Attributes
value_type | _v [4]
## Friends
std::ostream & | operator<< (std::ostream &output, const Vec4f &vec)

## Detailed Description

General purpose float quad.

Uses include representation of color coordinates. No support yet added for float * Vec4f - is it necessary? Need to define a non-member non-friend operator* etc. Vec4f * float is okay

## Member Typedef Documentation

typedef float osg::Vec4f::value_type

## Constructor & Destructor Documentation

osg::Vec4f::Vec4f | ( |  | ) | `[inline]`

osg::Vec4f::Vec4f | ( | value_type | x,
|  | value_type | y,
|  | value_type | z,
|  | value_type | w
| ) | `[inline]`

osg::Vec4f::Vec4f | ( | const Vec3f & | v3,
|  | value_type | w
| ) | `[inline]`

## Member Function Documentation

unsigned long osg::Vec4f::asABGR | ( |  | ) | const`[inline]`

unsigned long osg::Vec4f::asRGBA | ( |  | ) | const`[inline]`

bool osg::Vec4f::isNaN | ( |  | ) | const`[inline]`

value_type osg::Vec4f::length | ( |  | ) | const`[inline]`

| Length of the vector = sqrt( vec . vec )

value_type osg::Vec4f::length2 | ( |  | ) | const`[inline]`

| Length squared of the vector = vec . vec

value_type osg::Vec4f::normalize | ( |  | ) | `[inline]`

| Normalize the vector so that it has length unity. Returns the previous length of the vector.

Vec4f osg::Vec4f::operator * | ( | value_type | rhs | ) | const`[inline]`

| Multiply by scalar.

value_type osg::Vec4f::operator * | ( | const Vec4f & | rhs | ) | const`[inline]`

| Dot product.

Vec4f& osg::Vec4f::operator *= | ( | value_type | rhs | ) | `[inline]`

| Unary multiply by scalar.

bool osg::Vec4f::operator!= | ( | const Vec4f & | v | ) | const`[inline]`

Vec4f osg::Vec4f::operator+ | ( | const Vec4f & | rhs | ) | const`[inline]`

| Binary vector add.

Vec4f& osg::Vec4f::operator+= | ( | const Vec4f & | rhs | ) | `[inline]`

| Unary vector add. Slightly more efficient because no temporary intermediate object.

const Vec4f osg::Vec4f::operator- | ( |  | ) | const`[inline]`

| Negation operator. Returns the negative of the Vec4f.

Vec4f osg::Vec4f::operator- | ( | const Vec4f & | rhs | ) | const`[inline]`

| Binary vector subtract.

Vec4f& osg::Vec4f::operator-= | ( | const Vec4f & | rhs | ) | `[inline]`

| Unary vector subtract.

Vec4f osg::Vec4f::operator/ | ( | value_type | rhs | ) | const`[inline]`

| Divide by scalar.

Vec4f& osg::Vec4f::operator/= | ( | value_type | rhs | ) | `[inline]`

| Unary divide by scalar.

bool osg::Vec4f::operator< | ( | const Vec4f & | v | ) | const`[inline]`

bool osg::Vec4f::operator== | ( | const Vec4f & | v | ) | const`[inline]`

value_type osg::Vec4f::operator[] | ( | unsigned int | i | ) | const`[inline]`

value_type& osg::Vec4f::operator[] | ( | unsigned int | i | ) | `[inline]`

const value_type* osg::Vec4f::ptr | ( |  | ) | const`[inline]`

value_type* osg::Vec4f::ptr | ( |  | ) | `[inline]`

void osg::Vec4f::set | ( | value_type | x,
|  | value_type | y,
|  | value_type | z,
|  | value_type | w
| ) | `[inline]`

bool osg::Vec4f::valid | ( |  | ) | const`[inline]`

value_type osg::Vec4f::w | ( |  | ) | const`[inline]`

value_type& osg::Vec4f::w | ( |  | ) | `[inline]`

value_type osg::Vec4f::x | ( |  | ) | const`[inline]`

value_type& osg::Vec4f::x | ( |  | ) | `[inline]`

value_type osg::Vec4f::y | ( |  | ) | const`[inline]`

value_type& osg::Vec4f::y | ( |  | ) | `[inline]`

value_type osg::Vec4f::z | ( |  | ) | const`[inline]`

value_type& osg::Vec4f::z | ( |  | ) | `[inline]`

## Friends And Related Function Documentation

std::ostream& operator<< | ( | std::ostream & | output,
|  | const Vec4f & | vec
| ) | `[friend]`

## Member Data Documentation

value_type osg::Vec4f::_v[4]

The documentation for this class was generated from the following file:

- Vec4f